"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PetsController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const pet_schema_1 = require("../schemas/pet.schema");
const pet_service_1 = require("../services/pet.service");
let PetsController = class PetsController {
    constructor(petsService) {
        this.petsService = petsService;
    }
    async findAll() {
        return this.petsService.findAll();
    }
    async findById(id) {
        return this.petsService.findById(id);
    }
    async create(pet) {
        return this.petsService.create(pet);
    }
    async update(id, pet) {
        return this.petsService.update(id, pet);
    }
    async delete(id) {
        return this.petsService.delete(id);
    }
    async findAllDog() {
        return this.petsService.findAllDog();
    }
    async findAllCat() {
        return this.petsService.findAllCat();
    }
    async findAllBird() {
        return this.petsService.findAllBird();
    }
    async findAllReptile() {
        return this.petsService.findAllReptile();
    }
    async loveReaction(id) {
        return this.petsService.loveReaction(id);
    }
};
__decorate([
    (0, common_1.Get)('getall'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/pet.schema").Pet] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "findAll", null);
__decorate([
    (0, common_1.Get)('getbyid/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/pet.schema").Pet }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "findById", null);
__decorate([
    (0, common_1.Post)('create'),
    openapi.ApiResponse({ status: 201, type: require("../schemas/pet.schema").Pet }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [pet_schema_1.Pet]),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('update/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/pet.schema").Pet }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, pet_schema_1.Pet]),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "update", null);
__decorate([
    (0, common_1.Delete)('delete/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/pet.schema").Pet }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "delete", null);
__decorate([
    (0, common_1.Get)('getalldog'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/pet.schema").Pet] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "findAllDog", null);
__decorate([
    (0, common_1.Get)('getallcat'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/pet.schema").Pet] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "findAllCat", null);
__decorate([
    (0, common_1.Get)('getallbird'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/pet.schema").Pet] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "findAllBird", null);
__decorate([
    (0, common_1.Get)('getallreptile'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/pet.schema").Pet] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "findAllReptile", null);
__decorate([
    (0, common_1.Put)('love/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/pet.schema").Pet }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PetsController.prototype, "loveReaction", null);
PetsController = __decorate([
    (0, swagger_1.ApiTags)('Pets'),
    (0, common_1.Controller)('pets'),
    __metadata("design:paramtypes", [pet_service_1.PetService])
], PetsController);
exports.PetsController = PetsController;
//# sourceMappingURL=pet.controller.js.map