"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuestionMarksController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const questionMarks_schema_1 = require("../schemas/questionMarks.schema");
const questionMarks_service_1 = require("../services/questionMarks.service");
const platform_express_1 = require("@nestjs/platform-express");
let QuestionMarksController = class QuestionMarksController {
    constructor(questionMarksService) {
        this.questionMarksService = questionMarksService;
    }
    async create(assignmentFile, questionMarks) {
        var _a;
        try {
            if (assignmentFile) {
                questionMarks.assignmentFile = (_a = assignmentFile === null || assignmentFile === void 0 ? void 0 : assignmentFile.buffer) === null || _a === void 0 ? void 0 : _a.toString("base64");
            }
            return await this.questionMarksService.create(questionMarks);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(questionMarksId, updatedQuestionMarks) {
        try {
            return await this.questionMarksService.edit(questionMarksId, updatedQuestionMarks);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getById(questionMarksId) {
        try {
            return await this.questionMarksService.getById(questionMarksId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByStudentId(studentId) {
        try {
            return await this.questionMarksService.getByStudentId(studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByStudentAndCourseId(courseId, studentId) {
        try {
            return await this.questionMarksService.getByStudentAndCourseId(courseId, studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByTo10Students(courseId) {
        try {
            return await this.questionMarksService.getByTo10Students(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByStudentAndLessonId(lessonId, studentId) {
        try {
            return await this.questionMarksService.getByStudentAndLessonId(lessonId, studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getDetailsQuestionMarksByStudentId(studentId) {
        try {
            return await this.questionMarksService.getDetailsQuestionMarksByStudentId(studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async delete(questionMarksId) {
        try {
            return await this.questionMarksService.delete(questionMarksId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Post)('create'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)("assignmentFile")),
    openapi.ApiResponse({ status: 201, type: require("../schemas/questionMarks.schema").QuestionMarks }),
    __param(0, (0, common_1.UploadedFile)()),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, questionMarks_schema_1.QuestionMarks]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('edit/:questionMarksId'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/questionMarks.schema").QuestionMarks }),
    __param(0, (0, common_1.Param)('questionMarksId')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, questionMarks_schema_1.QuestionMarks]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)(':questionMarksId'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/questionMarks.schema").QuestionMarks }),
    __param(0, (0, common_1.Param)('questionMarksId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)('get-by-student/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/questionMarks.schema").QuestionMarks] }),
    __param(0, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "getByStudentId", null);
__decorate([
    (0, common_1.Get)('get-by-courseId/:courseId/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/questionMarks.schema").QuestionMarks] }),
    __param(0, (0, common_1.Param)('courseId')),
    __param(1, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "getByStudentAndCourseId", null);
__decorate([
    (0, common_1.Get)('get-by-top-students/:courseId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/questionMarks.schema").QuestionMarks] }),
    __param(0, (0, common_1.Param)('courseId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "getByTo10Students", null);
__decorate([
    (0, common_1.Get)('get-by-lessonId/:lessonId/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/questionMarks.schema").QuestionMarks] }),
    __param(0, (0, common_1.Param)('lessonId')),
    __param(1, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "getByStudentAndLessonId", null);
__decorate([
    (0, common_1.Get)('get-details-by-studentId/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/questionMarks.schema").QuestionMarks] }),
    __param(0, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "getDetailsQuestionMarksByStudentId", null);
__decorate([
    (0, common_1.Delete)('delete/:questionMarksId'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('questionMarksId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], QuestionMarksController.prototype, "delete", null);
QuestionMarksController = __decorate([
    (0, swagger_1.ApiTags)("QuestionMarks"),
    (0, common_1.Controller)('questionMarks'),
    __metadata("design:paramtypes", [questionMarks_service_1.QuestionMarksService])
], QuestionMarksController);
exports.QuestionMarksController = QuestionMarksController;
//# sourceMappingURL=questionMarks.controller.js.map